/*
	$Id: plugin.h,v 1.3 2003/09/22 15:36:31 crosser Exp $

	$Log: plugin.h,v $
	Revision 1.3  2003/09/22 15:36:31  crosser
	eliminate stage chain, leave only lhash
	
	Revision 1.2  2003/09/14 21:16:17  crosser
	I hardly beleive it but the new varpool thing seems to work!
	
	Revision 1.1  2003/09/14 14:00:06  crosser
	begin introduction of lhash...
	
*/

/*
	WHAT IS IT:
		modularized contentfilter for Zmailer
	COPYRIGHT:
		(c) 2003 Eugene G. Crosser <crosser@average.org>
	LICENSE:
		The same set as apply to Zmailer code
*/

#ifndef PLUGIN_H
#define PLUGIN_H

#define MAXNAME 32

struct _plugin {
	struct _plugin *next;
	char name[MAXNAME];
	int (*init_func)(void **priv);
	void (*term_func)(void **priv);
	int (*scan_func)(char *stage,int depth,
			slab_t data,varpool_t vp,void *priv);
	void *priv;
};

struct _stage {
	char name[MAXNAME];
	struct _plugin *plugin;
};

extern struct _stage *stages;
extern LHASH *stagehash;

#endif
